
\documentclass[border={35pt 10pt 140pt 60pt}, % left bottom right top
			  svgnames]{standalone} 

\usepackage{xcolor}
\usepackage{pgfplots}
\usetikzlibrary{positioning}

\usepackage{listings}
\lstset{%
	frame = tb, % draw a frame at the top and bottom of the code block
	tabsize = 1, % tab space width
	showstringspaces = false, % do not mark spaces in strings
	numbers=left, % display line numbers on the left
	commentstyle = \color{Green}, % comment color
	keywordstyle = \color{blue}, % keyword color
	stringstyle = \color{DarkRed}, % string color
	backgroundcolor	=\color{WhiteSmoke}, % backgroundcolor color
	framesep = 3pt, % expand outward.
	framerule = 0.4pt ,% expand outward. 
}

\begin{document}
		
	\begin{lstlisting}[language= C++, numbers=none, escapechar=!, basicstyle = \ttfamily\bfseries, linewidth = .6\linewidth] 
 int!\tikz[remember picture]\node[] (a){};!puissance!\tikz[remember picture]\node[] (b){};!(int x,!\tikz[ remember picture]\node[](c){};!int n) { 

		 int i, p = 1; !\tikz[remember picture] \node[] (d){};!           

		 for (i = 1; i <= n; i++) 
			 p = p * x; !\tikz[remember picture] \node[inner xsep = 40pt] (e){};! 

		 return p; !\tikz[remember picture] \node[] (f){};!  
 }
	\end{lstlisting}

	\begin{tikzpicture}[remember picture, overlay, scale = 0.6]
		\tikzset{
			arrowstyle/.style = { ->, thick, >=stealth, DimGray, dashed, line width = 1pt },
			nodestyle/.style = { align = center, minimum height = 10pt, font = \bfseries, fill= green!20}, text width = 2.5cm }

		\node[nodestyle, above left = .75cm and -.75 cm of a,text width = 2.2cm]  (A) {return value type};

		\node[nodestyle, right = 0.25cm of A, text width = 1.9cm]  (B) {function name};

		\node[nodestyle, right = 0.5cm of B]  (C) {list of formal parameters};

		\node[nodestyle, right = 4.cm of d]  (D) {local variables declaration};

		\node[nodestyle, right = 2.cm of e]  (E) {instructions};

		\node[nodestyle, right = 5.cm of f]  (F) {instruction \texttt{\bfseries return}};	

		\draw[arrowstyle] (A.south) + (0, 0) coordinate(x1)-- (x1|-a.north);
		\draw[arrowstyle] (B.south) + (0, 0) coordinate(x2)-- (x2|-b.north);
		\draw[arrowstyle] (C.south) + (0, 0) coordinate(x3)-- (x3|-c.north);
		\draw[arrowstyle] (D.west) to (d.east) ;
		\draw[arrowstyle] (E.west) to (e.east) ;	
		\draw[arrowstyle] (F.west) to (f.east) ;
\end{tikzpicture} 

\end{document}